var UIP;

function ImportarCatalogoMateriaPrima(){
	var IMateriaPrima;
	var FSystem;
	var TextStream;
	var stArray=new Array();
	var stFile;
	var stLine;
	var itLines;
	var itCount=0;
	var stTemp;
	var codigoP="";
	
	var unidad="";
	var factor = "";
	var unidadB = "";
	
	UIP=Application.NewUIProgress();
	UIP.Caption="Importando materias primas"
	UIP.Min=0;
	
	stFile=Application.OpenFile("Archivos de texto (*.txt)|*.txt");
	
	if (stFile==""){
		return false;
	}
	
	FSystem=Application.NewObject("Scripting.FileSystemObject");
	IMateriaPrima=Application.NewObject("EDOFx.Producto");
	IMateriaPrima.ADOCnn=Application.adoCnn;
	TextStream=FSystem.OpenTextFile(stFile);
	
	if (FSystem.FileExists(stFile)==false){
		return false;
	}
	
	itLines=LinesCount(stFile, FSystem);
	UIP.Max=itLines+1;
	UIP.Show();
	itLines=1;
	
	Application.MouseHourglass();
	Application.eDoEvents();
	
	while (TextStream.AtEndOfStream==false){
		try{
		
			stLine=TextStream.ReadLine();
			stArray=stLine.split("|");
			
			IMateriaPrima.AddNew();
			
			if (IMateriaPrima.LoadFromADOCByCodigo(stArray[0])==false){
				
				codigoP="";
				codigoP=stArray[0];
				codigoP=codigoP+"";
				codigoP=codigoP.toUpperCase();
				IMateriaPrima.Codigo=codigoP;
				
				unidad=stArray[2];
				factor= stArray[3];					
				unidadB=stArray[4];
				
				if(unidad == null || unidad == ""){
					Log("Error al procesar fila "+itLines+". Debe indicar una unidad estandar.");
				}else{
					if(factor == "" || factor == null){
						Log("Error al procesar fila "+itLines+". Debe indicar un factor de unidad");
					}else{
						if(unidadB == "" || unidadB == null){
							Log("Error al procesar fila "+itLines+". Debe indicar una unidad de compra");
						}else{
						
							IMateriaPrima.Descripcion=stArray[1];
							/*IMateriaPrima.Unidad=stArray[2];
							IMateriaPrima.UnidadB=IMateriaPrima.Unidad;*/
							
							IMateriaPrima.Unidad = unidad;
							IMateriaPrima.FactorB = factor;
							IMateriaPrima.UnidadB= unidadB;
							
							UIP.TopTitle="Almacenando "+IMateriaPrima.Descripcion;
							
							if (IMateriaPrima.IDivisa.LoadFromADOCByCodigo(stArray[5])==true){
								if (IMateriaPrima.ILinea.LoadFromADOCByCodigo(stArray[6])==true){
									
									stTemp=stArray[7]+"";
									switch (stTemp.toUpperCase()){
										case "I":
											IMateriaPrima.ITipo = 2;//Inventariable
											break;
										case "NI":
											IMateriaPrima.ITipo = 1;//No inventariable
											break;						
										default:
											IMateriaPrima.ITipo = 2;//Inventariable
											break;
									}
									
									IMateriaPrima.IClase = 1;//Clase cMateria_prima
						
									if(stArray[8]>=1 && stArray[8]<=4){
										IMateriaPrima.MetodoValuacion=stArray[8];
									}else{
										IMateriaPrima.MetodoValuacion=99;
									}
									
									stTemp=stArray[9]+"";
									
									switch (stTemp.toUpperCase()){
										case "G16":
											IMateriaPrima.Impuestos.LoadFromADOCByNombre("IVA 16% (Mxico)");
											break;
										case "G15":
											IMateriaPrima.Impuestos.LoadFromADOCByNombre("IVA 15% (Mxico)");
											break;
										case "G0":
											IMateriaPrima.Impuestos.LoadFromADOCByNombre("IVA 0% (Mxico)");
											break;
										case "E":
											IMateriaPrima.Impuestos.LoadFromADOCByNombre("Exento");
											break;
										default:
											IMateriaPrima.Impuestos.LoadFromADOCByNombre("IVA 0% (Mxico)");
											break;
									}
						
									IMateriaPrima.CostoUltimo=parseFloat("0"+stArray[10]);
									
									IMateriaPrima.IMarca.LoadFromADOCByCodigo(stArray[11]);
									IMateriaPrima.IDepartamento.LoadFromADOCByCodigo(stArray[12]);
									IMateriaPrima.CodBar1=stArray[13];
									IMateriaPrima.CodBar2=stArray[14];
									IMateriaPrima.CodBar3=stArray[15];
									
									IMateriaPrima.Visible=true;
									
									if (!IMateriaPrima.Update()){
										Log("Error al procesar fila "+itLines+". Error al guardar materia prima ("+IMateriaPrima.Descripcion+") "+IMateriaPrima.lastErrDescrip);
									}
									else{
										itCount=itCount+1;
									}
								}else{
									Log("Error al procesar fila "+itLines+". No se pudo cargar la lnea de la materia prima con cdigo: "+stArray[0]);
								}
								}else{
									Log("Error al procesar fila "+itLines+". No se pudo cargar la divisa de la materia prima con cdigo: "+stArray[0]);
								}
							}
						}
					}
				}else{
					Log("Error al procesar fila "+itLines+". La materia prima con cdigo "+stArray[0]+" ya se encuentra registrado.");
				}
				
		}catch(e){
			Log("Error al procesar fila "+itLines);
		}
		itLines=itLines+1;
		UIP.Value=itLines;		
		Application.eDoEvents();
	}
	Application.CloseUIProgress(UIP);
	Application.MouseDefault();
	eBasic.eMsgbox ("Cantidad de registros importados: "+itCount,6); 	
	TextStream.Close();
	IMateriaPrima=null;
	FSystem=null;
	TextStream=null;
	stArray=null;
	return true;
}

function Log(Error){
	if (Error!="")
		Application.FireEventLog(Error);
}

function LinesCount(strFile, FSystemO){
	var StreamO;
	var itCount=0;

	StreamO=FSystemO.OpenTextFile(strFile);
	
	while (StreamO.AtEndOfStream==false){
		itCount=itCount+1;
		StreamO.SkipLine();
	}
	
	StreamO.Close();
	StreamO=null;
	return itCount;
}

function Procesar(){
	try{
		return ImportarCatalogoMateriaPrima();
	}catch(e)
	{
		if(UIP!=null){
			Application.CloseUIProgress(UIP);
			Application.MouseDefault();
		}
		Log("Error al ejecutar subprograma");
		throw e;
		return false;
	}
}
Procesar();