var UIP;

function ImportarCatalogoMateriaPrima(){	
	var IMateriaPrima;
	var EFile;
	var ESheet;
	var lgItems;
	var itRows;
	var stFile;
	var stTemp;
	var itCount=0;
	var codigoP="";
	
	var unidad="";
	var factor = "";
	var unidadB = "";
	
	stFile=Application.OpenFile("Archivos de excel (*.xls)|*.xls");	
	if (stFile==""){		
		return false;
	}
		
	UIP=Application.NewUIProgress();
	UIP.Caption="Importando materias primas";
	UIP.Min=0;
	
	EFile=Application.NewObject("Excel.Application");
	EFile.WorkBooks.Open (stFile);
	IMateriaPrima=Application.NewObject("EDOFx.Producto");
	IMateriaPrima.ADOCnn=Application.adoCnn;
	
    // si es la versin de Excel 97, asigna la hoja activa ( ActiveSheet )
	if (EFile.Application.Version>=8){
		ESheet = EFile.ActiveSheet;
	}
	else{
		ESheet = EFile;
	}
	
	itRows=ESheet.UsedRange.Rows.Count;
	UIP.Max=itRows;
	UIP.Show();
	
	Application.MouseHourglass();
		
	for (lgItems=2;lgItems<=itRows;lgItems++){
		try{
		
			IMateriaPrima.AddNew();
					
			if (IMateriaPrima.LoadFromADOCByCodigo(ESheet.Cells(lgItems,1))==false){
				codigoP="";
				codigoP=ESheet.Cells(lgItems,1);						
				codigoP=codigoP+"";
				codigoP=codigoP.toUpperCase();
				IMateriaPrima.Codigo=codigoP;
				
				unidad = ESheet.Cells(lgItems,3);
				factor = ESheet.Cells(lgItems,4)+"";
				unidadB = ESheet.Cells(lgItems,5)+"";
				
				if(unidad == null || unidad == ""){
					Log("Error al procesar fila "+lgItems+". Debe indicar una unidad estandar.");
				}else{
					if(factor == "undefined"){
						Log("Error al procesar fila "+lgItems+". Debe indicar un factor de unidad");
					}else{
						if(unidadB == "undefined"){
							Log("Error al procesar fila "+lgItems+". Debe indicar una unidad de compra");
						}else{
							
							IMateriaPrima.Descripcion=ESheet.Cells(lgItems,2);
							/*IMateriaPrima.Unidad=ESheet.Cells(lgItems,3);							
							IMateriaPrima.UnidadB=IMateriaPrima.Unidad;*/
							IMateriaPrima.Unidad = unidad;
							IMateriaPrima.FactorB = factor;
							IMateriaPrima.UnidadB= unidadB;
							
							UIP.TopTitle="Almacenando "+IMateriaPrima.Descripcion;
							
							if (IMateriaPrima.IDivisa.LoadFromADOCByCodigo(ESheet.Cells(lgItems,6))==true){
								if (IMateriaPrima.ILinea.LoadFromADOCByCodigo(ESheet.Cells(lgItems,7))==true){
									
									stTemp=ESheet.Cells(lgItems,8)+"";									
									switch (stTemp.toUpperCase()){
										case "I":
											IMateriaPrima.ITipo = 2;//Inventariable
										break;
										
										case "NI":
											IMateriaPrima.ITipo = 1;//No inventariable
										break;
										default:
											IMateriaPrima.ITipo = 2;//Inventariable
										break;
									}
						
									IMateriaPrima.IClase = 1;//Clase cMateria_prima
						
									stTemp=ESheet.Cells(lgItems,9);
									
									if (stTemp>=1 && stTemp<=4){
										IMateriaPrima.MetodoValuacion=stTemp;
									}else{
										IMateriaPrima.MetodoValuacion=99;
									}
									
									stTemp=ESheet.Cells(lgItems,10)+"";
									
									switch (stTemp.toUpperCase()){
										case "G16":
											IMateriaPrima.Impuestos.LoadFromADOCByNombre("IVA 16% (Mxico)");
											break;
										case "G15":
											IMateriaPrima.Impuestos.LoadFromADOCByNombre("IVA 15% (Mxico)");
											break;
										case "G0":
											IMateriaPrima.Impuestos.LoadFromADOCByNombre("IVA 0% (Mxico)");
											break;
										case "E":
											IMateriaPrima.Impuestos.LoadFromADOCByNombre("Exento");
											break;
										default:
											IMateriaPrima.Impuestos.LoadFromADOCByNombre("IVA 0% (Mxico)");
											break;
									}
						
									IMateriaPrima.CostoUltimo=ESheet.Cells(lgItems,11);
									
									IMateriaPrima.IMarca.LoadFromADOCByCodigo(ESheet.Cells(lgItems,12));
									IMateriaPrima.IDepartamento.LoadFromADOCByCodigo(ESheet.Cells(lgItems,13));
									IMateriaPrima.CodBar1=ESheet.Cells(lgItems,14);
									IMateriaPrima.CodBar2=ESheet.Cells(lgItems,15);
									IMateriaPrima.CodBar3=ESheet.Cells(lgItems,16);
									
									IMateriaPrima.Visible=true;
						
									if (!IMateriaPrima.Update()){
										Log("Error al procesar fila "+lgItems+". Error al guardar materia prima ("+IMateriaPrima.Descripcion+") "+IMateriaPrima.lastErrDescrip);
									}
									else{
										itCount=itCount+1;
									}
								}else{
									Log("Error al procesar fila "+lgItems+". No se pudo cargar la lnea de la materia prima con cdigo: "+ESheet.Cells(lgItems,1));
								}
								}else{
									Log("Error al procesar fila "+lgItems+". No se pudo cargar la divisa de la materia prima con cdigo: "+ESheet.Cells(lgItems,1));
								}
							}
						}
					}
				}else{
					Log("Error al procesar fila "+lgItems+". La materia prima con cdigo "+ESheet.Cells(lgItems,1)+" ya se encuentra registrado.");
				}
				
		}catch(e){
			Log("Error al procesar fila "+lgItems);
		}
		UIP.Value=lgItems;
		Application.eDoEvents();
	}
	
	Application.CloseUIProgress(UIP);
	Application.MouseDefault();
	eBasic.eMsgbox("Cantidad de registros importados "+itCount,6);
	EFile.ActiveWorkBook.Close(false);
	EFile.Quit();
	IMateriaPrima=null;
	EFile=null;
	ESheet=null;
	return true;
}

function Log(Error){
	if (Error!="")
		Application.FireEventLog(Error);
}

function Procesar(){
	try{
		return ImportarCatalogoMateriaPrima();
	}catch(e)
	{
		if(UIP!=null){
			Application.CloseUIProgress(UIP);
			Application.MouseDefault();
		}
		Log("Error al ejecutar subprograma");
		throw e;
		return false;
	}
}
Procesar();